<?php
/*
    $Id: packaging.php,v 1.5 2015/05/22 $
    
    Copyright (c) 2003 Torin Walker
    
    This program is free software; you can redistribute it and/or modify it under the terms
    of the GNU General Public License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
    
    This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
    without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
    See the GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License along with this program;
    If not, you may obtain one by writing to and requesting one from
    
    The Free Software Foundation, Inc.,
    59 Temple Place, Suite 330,
    Boston, MA 02111-1307 USA
*/

require('includes/application_top.php');
require(DIR_WS_CLASSES . 'currencies.php');
$currencies = new currencies();

  require(DIR_WS_INCLUDES . 'template_top.php');   
?>
<!-- body //-->
<p class="main"><span class="pageHeading"><?php echo HEADING_TITLE . '</span><span style="float: right">' . tep_draw_button(CREATE_NEW_PACKAGE, 'plusthick', tep_href_link(FILENAME_PACKAGING, 'Action=shownewpackageform')) . '</span>'; ?></p>
<table border="0" width="100%" cellspacing="0" cellpadding="0">
  <tr>
    <td class="main" width="75%" valign="top">
<?php
$activeid = isset($_GET['id']) ? $_GET['id'] : '';
$action = isset($_GET['Action']) ? $_GET['Action'] : '';
$post_action = isset($_POST['Action']) ? $_POST['Action'] : '';
$posted_id = isset($_POST['id']) ? tep_db_prepare_input($_POST['id']) : '';
$pkgname = isset($_POST['name']) ? tep_db_prepare_input($_POST['name']) : '';
$error = '';

//********** New Package
if ($pkgname != "" && (($post_action == "newpackage") || ($posted_id != "" && $post_action == "updatepackage"))) {
	$length = round((float)tep_db_prepare_input($_POST['length']), 3);
	$width = round((float)tep_db_prepare_input($_POST['width']), 3);
	$height = round((float)tep_db_prepare_input($_POST['height']), 3);
	$empty_weight = round((float)tep_db_prepare_input($_POST['empty_weight']), 2);
	$max_weight = round((float)tep_db_prepare_input($_POST['max_weight']), 2);
  if ($length <= 0) {
    $error = MIN_LENGTH_NOT_MET;
  } elseif ($width <= 0) {
    $error = MIN_WIDTH_NOT_MET;
  } elseif ($height <= 0) {
    $error = MIN_HEIGHT_NOT_MET;
  } elseif ($empty_weight <= 0) {	
    $error = MIN_EMPTY_WEIGHT_NOT_MET;
  } elseif ($max_weight < 0) {	
    $error = MIN_MAX_WEIGHT_NOT_MET;
  } else {
    $sql_data_array = array(
        'package_name' => $pkgname,
        'package_description' => tep_db_prepare_input($_POST['description']),
        'package_length' => $length,
        'package_width' => $width,
        'package_height' => $height,
        'package_empty_weight' => $empty_weight,
        'package_max_weight' => $max_weight,
        'package_cost' => (int)tep_db_prepare_input($_POST['cost'])
    );
    if ($post_action == 'newpackage') {
      tep_db_perform(TABLE_PACKAGING, $sql_data_array);
			$activeid = tep_db_insert_id();
    } else {
      tep_db_perform(TABLE_PACKAGING, $sql_data_array, "update", "package_id = '" . (int)$posted_id . "'");
    }
  }
	if ($error != '') {
		if ($post_action == 'newpackage') {
			$action = 'shownewpackageform';
		} else {
			$action = 'showupdatepackageform';
			$activeid = $posted_id;
		}
	}
}

//********** Delete Package
if ($posted_id != "" && $post_action == "deletepackage") {
  tep_db_query("delete from " . TABLE_PACKAGING . " where package_id = '" . (int)$posted_id . "'");
}

// ********* Display Packages
$packages = getPackages();
DisplayPackages($activeid, $error);
switch ($action) {
  case "shownewpackageform":
    showNewPackageForm();
    break;
  case "showupdatepackageform":
    showUpdatePackageForm();
    break;
  case "showconfirmdeletepackageform":
    showConfirmDeletePackageForm();
    break;
  default:
    showPackageInfoForm();
    break;
}

//*******************
function getPackages() {
  $packages = array();
  $packages_query = tep_db_query("select * from " . TABLE_PACKAGING . " order by package_cost;");
  while ($package = tep_db_fetch_array($packages_query)) {
    $packages[] = array(
        'id' => $package['package_id'],
        'name' => $package['package_name'],
        'description' => $package['package_description'],
        'length' => $package['package_length'],
        'width' => $package['package_width'],
        'height' => $package['package_height'],
        'empty_weight' => $package['package_empty_weight'],
        'max_weight' => $package['package_max_weight'],
        'cost' => $package['package_cost']
    );
  }
  return $packages;
}

//************************  DisplayPackages()
// shows the main menu, lists the admins
function DisplayPackages($activeid, $error) {
	global $action, $packages;
?>
    <table border="0" width="100%" cellspacing="0" cellpadding="2">
      <tr class="dataTableHeadingRow">
        <td class="dataTableHeadingContent"><?php echo HEADING_NAME; ?></td>
        <td class="dataTableHeadingContent" align="left"><?php echo HEADING_DESCRIPTION; ?></td>
        <td class="dataTableHeadingContent" align="center"><?php echo HEADING_LENGTH; ?></td>
        <td class="dataTableHeadingContent" align="center"><?php echo HEADING_WIDTH; ?></td>
        <td class="dataTableHeadingContent" align="center"><?php echo HEADING_HEIGHT; ?></td>
        <td class="dataTableHeadingContent" align="center"><?php echo HEADING_EMPTY_WEIGHT; ?></td>
        <td class="dataTableHeadingContent" align="center"><?php echo HEADING_MAX_WEIGHT; ?></td>
        <td class="dataTableHeadingContent" align="center"><?php echo HEADING_COST; ?></td>
        <td class="dataTableHeadingContent" align="left"><?php echo HEADING_ACTION; ?></td>
      </tr>
    <?php
    if (count($packages) == 0) {
      echo '<tr><td colspan="8"><strong>' . NO_PACKAGES_DEFINED . "</strong></td></tr>\n";
    } elseif ($activeid == "") {
      $activeid = $packages[0]['id'];
    }
    if ($error != "") {
      echo '<tr><td colspan="8" class="errorText"><strong>' . $error . "</strong></td></tr>\n";
    }
    for ($i = 0; $i < count($packages); $i++) {
      if ($activeid == $packages[$i]['id']) {
        echo '<tr id="defaultSelected" class="dataTableRowSelected" onmouseover="rowOverEffect(this)" onmouseout="rowOutEffect(this)" onclick="document.location.href=\'' . tep_href_link(FILENAME_PACKAGING, 'Action=showupdatepackageform&id=' . $packages[$i]['id'] ).'\'">' . "\n";
      } else {
        echo '<tr class="dataTableRow" onmouseover="rowOverEffect(this)" onmouseout="rowOutEffect(this)" onclick="document.location.href=\'' . tep_href_link(FILENAME_PACKAGING, 'id=' .$packages[$i]['id'] ). '\'">' . "\n";
      }
      echo '<td class="dataTableContent" align="left">' . $packages[$i]['name'] . "</td>\n";
      echo '<td class="dataTableContent" align="left">' . $packages[$i]['description'] . "</td>\n";
      echo '<td class="dataTableContent" align="center">' . $packages[$i]['length'] . "</td>\n";
      echo '<td class="dataTableContent" align="center">' . $packages[$i]['width'] . "</td>\n";
      echo '<td class="dataTableContent" align="center">' . $packages[$i]['height'] . "</td>\n";
      echo '<td class="dataTableContent" align="center">' . $packages[$i]['empty_weight'] . "</td>\n";
      echo '<td class="dataTableContent" align="center">' . $packages[$i]['max_weight'] . "</td>\n";
      echo '<td class="dataTableContent" align="center">' . $packages[$i]['cost'] . "</td>\n";
      if ($activeid == $packages[$i]['id'] ) { 
        echo '<td>' . tep_image(DIR_WS_IMAGES . 'icon_arrow_right.gif', ''); 
      } else { 
        echo '<td><a href="' . tep_href_link(FILENAME_PACKAGING, 'id=' . $packages[$i]['id'] ). '">' . tep_image(DIR_WS_IMAGES . 'icon_info.gif', ICON_INFO) . '</a>'; 
      }
			echo "</td></tr>\n";
    }
    echo "</table><br>\n";
    echo tep_draw_button(CREATE_NEW_PACKAGE, 'plusthick', tep_href_link(FILENAME_PACKAGING, 'Action=shownewpackageform')) . '&nbsp;';
    echo tep_draw_button(IMAGE_EDIT, 'pencil', tep_href_link(FILENAME_PACKAGING, 'Action=showupdatepackageform&id=' . $activeid)) . '&nbsp;';	 
    echo tep_draw_button(IMAGE_DELETE, 'trash', tep_href_link(FILENAME_PACKAGING, 'Action=showconfirmdeletepackageform&id=' . $activeid)) . "\n";
    echo "</td>\n" . '<td width="25%" valign="top">' . "\n";
}

//******************************   showNewPackageForm()
// Show the form to create a new package
function showNewPackageForm() {
	global $activeid, $packages;
  $cost = 0;
  for ($i = 0; $i < count($packages); $i++) {
    if ($packages[$i]['cost'] > $cost) {
      $cost = $packages[$i]['cost'] + 1;
    }
  }
  echo '<table border="0" cellspacing="0" width="100%" cellpadding="2"><tr>';
  echo '<td class="infoBoxHeading"><strong>' . CREATE_NEW_PACKAGE. "</strong></td></tr></table>\n";
  echo tep_draw_form("newpackage", FILENAME_PACKAGING);
  echo tep_draw_hidden_field("Action", "newpackage");
  echo '<table border="0" cellspacing="0" width="100%" cellpadding="2">' . "\n";
	echo '<tr><td class="infoBoxContent"><strong>' . HEADING_NAME . '</strong></td></tr><tr><td class="infoBoxContent">' . HEADING_NAME_TEXT . '</td></tr><tr><td class="infoBoxContent">' . tep_draw_input_field("name") . "</td></tr>\n";
  echo '<tr><td class="infoBoxContent"><strong>' . HEADING_DESCRIPTION . '</strong></td></tr><tr><td class="infoBoxContent">' . HEADING_DESCRIPTION_TEXT . '</td></tr><tr><td class="infoBoxContent">' . tep_draw_input_field("description") . "</td></tr>\n";
  echo '<tr><td class="infoBoxContent"><strong>' . HEADING_LENGTH . '</strong></td></tr><tr><td class="infoBoxContent">' . HEADING_LENGTH_TEXT . '</td></tr><tr><td class="infoBoxContent">' . tep_draw_input_field("length") . "</td></tr>\n";
  echo '<tr><td class="infoBoxContent"><strong>' . HEADING_WIDTH . '</strong></td></tr><tr><td class="infoBoxContent">' . HEADING_WIDTH_TEXT . '</td></tr><tr><td class="infoBoxContent">' . tep_draw_input_field("width") . "</td></tr>\n";
  echo '<tr><td class="infoBoxContent"><strong>' . HEADING_HEIGHT . '</strong></td></tr><tr><td class="infoBoxContent">' . HEADING_HEIGHT_TEXT . '</td></tr><tr><td class="infoBoxContent">' . tep_draw_input_field("height") . "</td></tr>\n";
  echo '<tr><td class="infoBoxContent"><strong>' . HEADING_EMPTY_WEIGHT . '</strong></td></tr><tr><td class="infoBoxContent">' . HEADING_EMPTY_WEIGHT_TEXT . '</td></tr><tr><td class="infoBoxContent">' . tep_draw_input_field("empty_weight") . "</td></tr>\n";
  echo '<tr><td class="infoBoxContent"><strong>' . HEADING_MAX_WEIGHT . '</strong></td></tr><tr><td class="infoBoxContent">' . HEADING_MAX_WEIGHT_TEXT . '</td></tr><tr><td class="infoBoxContent">' . tep_draw_input_field("max_weight") . "</td></tr>\n";
  echo '<tr><td class="infoBoxContent"><strong>' . HEADING_COST . '</strong></td></tr><tr><td class="infoBoxContent">' . HEADING_COST_TEXT . '</td></tr><tr><td class="infoBoxContent">' . tep_draw_input_field("cost", $cost) . "</td></tr>\n";
  echo '<tr><td class="infoBoxContent" colspan="2">' . tep_draw_button(IMAGE_SAVE, 'disk') . '&nbsp;&nbsp;' . tep_draw_button(IMAGE_CANCEL, 'cancel', tep_href_link(FILENAME_PACKAGING, 'id=' . $activeid)) . "</td></tr></table>\n" ;
  echo "</form>\n";
}

//******************************   showUpdatePackageForm()
// Show the form to update a package
function showUpdatePackageForm() {
	global $activeid, $packages;
	if (count($packages) == 0) return; // nothing available to update
  $activepackage = $packages[0];
  if ($activeid != "") {
    for ($i = 0; $i < count($packages); $i++) {
      if ($activeid == $packages[$i]['id']) {
        $activepackage = $packages[$i];
      }
    }
  }
  echo '<table cellspacing="0" width="100%" cellpadding="2"><tr><td colspan="2" class="infoBoxHeading">' . UPDATE_PACKAGE . "</td></tr></table>\n";
  echo tep_draw_form("updatepackage", FILENAME_PACKAGING, 'id=' . $activepackage['id'], 'post');
  echo tep_draw_hidden_field("Action", "updatepackage");
  echo tep_draw_hidden_field("id", $activepackage['id']);
  echo '<table cellspacing="0" width="100%" cellpadding="2">' . "\n";
	echo '<tr><td class="infoBoxContent"><strong>' . HEADING_NAME . '</strong></td></tr><tr><td class="infoBoxContent">' . HEADING_NAME_TEXT . '</td></tr><tr><td class="infoBoxContent">' . tep_draw_input_field("name", $activepackage['name']) . "</td></tr>\n";
  echo '<tr><td class="infoBoxContent"><strong>' . HEADING_DESCRIPTION . '</strong></td></tr><tr><td class="infoBoxContent">' . HEADING_DESCRIPTION_TEXT . '</td></tr><tr><td class="infoBoxContent">' . tep_draw_input_field("description", $activepackage['description']) . "</td></tr>\n";
  echo '<tr><td class="infoBoxContent"><strong>' . HEADING_LENGTH . '</strong></td></tr><tr><td class="infoBoxContent">' . HEADING_LENGTH_TEXT . '</td></tr><tr><td class="infoBoxContent">' . tep_draw_input_field("length", $activepackage['length']) . "</td></tr>\n";
  echo '<tr><td class="infoBoxContent"><strong>' . HEADING_WIDTH . '</strong></td></tr><tr><td class="infoBoxContent">' . HEADING_WIDTH_TEXT . '</td></tr><tr><td class="infoBoxContent">' . tep_draw_input_field("width", $activepackage['width']) . "</td></tr>\n";
  echo '<tr><td class="infoBoxContent"><strong>' . HEADING_HEIGHT . '</strong></td></tr><tr><td class="infoBoxContent">' . HEADING_HEIGHT_TEXT . '</td></tr><tr><td class="infoBoxContent">' . tep_draw_input_field("height", $activepackage['height']) . "</td></tr>\n";
  echo '<tr><td class="infoBoxContent"><strong>' . HEADING_EMPTY_WEIGHT . '</strong></td></tr><tr><td class="infoBoxContent">' . HEADING_EMPTY_WEIGHT_TEXT . '</td></tr><tr><td class="infoBoxContent">' . tep_draw_input_field("empty_weight", $activepackage['empty_weight']) . "</td></tr>\n";
  echo '<tr><td class="infoBoxContent"><strong>' . HEADING_MAX_WEIGHT . '</strong></td></tr><tr><td class="infoBoxContent">' . HEADING_MAX_WEIGHT_TEXT . '</td></tr><tr><td class="infoBoxContent">' . tep_draw_input_field("max_weight", $activepackage['max_weight']) . "</td></tr>\n";
  echo '<tr><td class="infoBoxContent"><strong>' . HEADING_COST . '</strong></td></tr><tr><td class="infoBoxContent">' . HEADING_COST_TEXT . '</td></tr><tr><td class="infoBoxContent">'.tep_draw_input_field("cost", $activepackage['cost']) . "</td></tr>\n";
  echo '<tr><td class="infoBoxContent" colspan="2">' . tep_draw_button(IMAGE_SAVE, 'disk') . '&nbsp;&nbsp;' . tep_draw_button(IMAGE_CANCEL, 'cancel', tep_href_link(FILENAME_PACKAGING, 'id=' . $activeid)) . "</td></tr></table>\n" ;
  echo "</form>\n";
}

//*************************** showConfirmDeletePackageForm()
// Shows the form to confirm package deletion
function showConfirmDeletePackageForm() {
	global $activeid, $packages;
  $package_name = "";
  for ($i = 0; $i < count($packages); $i++) {
    if ($packages[$i]['id'] == $activeid) {
      $package_name = $packages[$i]['name'];
    }
  }
	if ($package_name == "") return; // no matching package
  echo '<table  border="0" width="100%" cellspacing="0" cellpadding="2"> <tr><td class="infoBoxHeading">' . DELETE_PACKAGE . "</td></tr></table>\n";
  echo tep_draw_form("confirmDeletePackage", FILENAME_PACKAGING);
  echo tep_draw_hidden_field("Action", "deletepackage");
  echo tep_draw_hidden_field("id", $activeid);
  echo '<table  border="0" width="100%" cellspacing="0" cellpadding="2"><tr><td class="infoBoxContent">' . CONFIRM_DELETE . "</td></tr>\n";
  echo '<tr><td class="infoBoxContent">' . $package_name . "</td></tr>\n";
  echo '<tr><td class="infoBoxContent">' . tep_draw_button(IMAGE_CONFIRM, 'trash') . '&nbsp;&nbsp;' . tep_draw_button(IMAGE_CANCEL, 'cancel', tep_href_link(FILENAME_PACKAGING));	 
  echo "</td></tr>\n</table>\n";
  echo "</form>\n";
}

//************************  ShowPackageInfo()
// Shows the info a package
function showPackageInfoForm() {
	global $activeid, $error, $packages;
  if ($error != "") {
    echo '<span class="errorText"><strong>'.$error.'</strong></span>';
  }
  echo '<table  border="0" width="100%" cellspacing="0" cellpadding="2"> <tr><td class="infoBoxHeading"><strong>' . HEADING_INFO . "</strong></td></tr></table>\n";
  if (count($packages) != 0) {
    $activepackage = $packages[0];
    if ($activeid != "") {
      for ($i = 0; $i < count($packages); $i++) {
        if ($activeid == $packages[$i]['id']) {
          $activepackage = $packages[$i];
        }
      }
    }
    echo '<table  border="0" width="100%" cellspacing="0" cellpadding="2">'."\n";
		echo '<tr><td class="infoBoxContent">' . tep_draw_button(IMAGE_EDIT, 'pencil', tep_href_link(FILENAME_PACKAGING, 'Action=showupdatepackageform&id=' . $activepackage['id'])) . '&nbsp;' . tep_draw_button(IMAGE_DELETE, 'trash', tep_href_link(FILENAME_PACKAGING, 'Action=showconfirmdeletepackageform&id=' . $activepackage['id'])) . "</td></tr>\n";
    echo '<tr><td class="infoBoxContent"><strong>' . HEADING_NAME . '</strong></td></tr><tr><td class="infoBoxContent">' . $activepackage['name'] . "</td></tr>\n";
    echo '<tr><td class="infoBoxContent"><strong>' . HEADING_DESCRIPTION . '</strong></td></tr><tr><td class="infoBoxContent">' . $activepackage['description'] . "</td></tr>\n";
    echo '<tr><td class="infoBoxContent"><strong>' . HEADING_LENGTH . '</strong></td></tr><tr><td class="infoBoxContent">' . $activepackage['length'] . "</td></tr>\n";
    echo '<tr><td class="infoBoxContent"><strong>' . HEADING_WIDTH . '</strong></td></tr><tr><td class="infoBoxContent">' . $activepackage['width'] . "</td></tr>\n";
    echo '<tr><td class="infoBoxContent"><strong>' . HEADING_HEIGHT . '</strong></td></tr><tr><td class="infoBoxContent">' . $activepackage['height'] . "</td></tr>\n";
    echo '<tr><td class="infoBoxContent"><strong>' . HEADING_EMPTY_WEIGHT . '</strong></td></tr><tr><td class="infoBoxContent">' . $activepackage['empty_weight'] . "</td></tr>\n";
    echo '<tr><td class="infoBoxContent"><strong>' . HEADING_MAX_WEIGHT . '</strong></td></tr><tr><td class="infoBoxContent">' . $activepackage['max_weight'] . "</td></tr>\n";
    echo '<tr><td class="infoBoxContent"><strong>' . HEADING_COST . '</strong></td></tr><tr><td class="infoBoxContent">' . $activepackage['cost'] . "</td></tr>\n";
    echo "</table>\n";
  }
}
?>
      </td>
    </tr>
  </table> 
</div>
<!-- body_text_eof //-->
<!-- body_eof //-->

<!-- footer //-->
<?php require(DIR_WS_INCLUDES . 'footer.php'); ?>
<!-- footer_eof //-->
<br>
</body>
</html>
<?php require(DIR_WS_INCLUDES . 'application_bottom.php'); ?>