<?php
/*
  $Id: upsxml.php, v1.71 2018-04-12  $

  Written by Torin Walker
  torinwalker@rogers.com
  
  Last update in accordance with UPS OnLine Tools, Rates and Service Selection Developers Guide,
  18 October 2007

  Copyright(c) 2003 by Torin Walker, All rights reserved.

  Released under the GNU General Public License
*/

	define('MODULE_SHIPPING_UPSXML_RATES_TEXT_TITLE', 'United Parcel Service');
	define('MODULE_SHIPPING_UPSXML_RATES_TEXT_ERROR', 'Error ');
	define('MODULE_SHIPPING_UPSXML_RATES_TEXT_EMAIL', 'Email');
	define('MODULE_SHIPPING_UPSXML_RATES_TEXT_DESCRIPTION', 'United Parcel Service (XML)');
	define('MODULE_SHIPPING_UPSXML_RATES_TEXT_UNKNOWN_ERROR', 'An unknown error occured with the UPS shipping calculations.');
	define('MODULE_SHIPPING_UPSXML_RATES_TEXT_RATES_ERROR', 'No valid shipping methods were returned by the UPS shipping calculations.');
	define('MODULE_SHIPPING_UPSXML_RATES_TEXT_IF_YOU_PREFER', 'If you prefer to use UPS as your shipping method, please contact');
	define('MODULE_SHIPPING_UPSXML_RATES_TEXT_COMM_ERROR', 'A communication error occured while attempting to contact the UPS gateway');
	define('MODULE_SHIPPING_UPSXML_RATES_TEXT_COMM_UNKNOWN_ERROR', 'An unknown error occured while attempting to contact the UPS gateway');
	define('MODULE_SHIPPING_UPSXML_RATES_TEXT_COMM_VERSION_ERROR', 'This module supports only xpci version 1.0001 of the UPS Rates Interface. Please contact the webmaster for additional assistance.');
	define('MODULE_SHIPPING_UPSXML_TIME_IN_TRANSIT_TEXT_NO_RATES','UPS returns success, but no EDDs were found');
	define('UPS_SATDEL', ' (Saturday Delivery)');
	if (defined('MODULE_SHIPPING_UPSXML_RATES_ORIGIN') && MODULE_SHIPPING_UPSXML_RATES_ORIGIN == 'Canada Origin') {
		define('UPS_SERVICE_CODE_01', 'UPS Express');
	} else {
		define('UPS_SERVICE_CODE_01', 'UPS Next Day Air');
	}
	define('UPS_SERVICE_CODE_02', 'UPS 2nd Day Air');
	define('UPS_SERVICE_CODE_03', 'UPS Ground');
	if (defined('MODULE_SHIPPING_UPSXML_RATES_ORIGIN') && ((MODULE_SHIPPING_UPSXML_RATES_ORIGIN == 'US Origin') || (MODULE_SHIPPING_UPSXML_RATES_ORIGIN == 'Canada Origin') || (MODULE_SHIPPING_UPSXML_RATES_ORIGIN == 'Puerto Rico Origin'))) {
		define('UPS_SERVICE_CODE_07', 'UPS Worldwide Express');
	} else {
		define('UPS_SERVICE_CODE_07', 'UPS Express');
	}
	if (defined('MODULE_SHIPPING_UPSXML_RATES_ORIGIN') && ((MODULE_SHIPPING_UPSXML_RATES_ORIGIN == 'US Origin') || (MODULE_SHIPPING_UPSXML_RATES_ORIGIN == 'Canada Origin') || (MODULE_SHIPPING_UPSXML_RATES_ORIGIN == 'Puerto Rico Origin'))) {
		define('UPS_SERVICE_CODE_08', 'UPS Worldwide Expedited');
	} else {
		define('UPS_SERVICE_CODE_08', 'UPS Expedited');
	}
	define('UPS_SERVICE_CODE_11', 'UPS Standard');
	define('UPS_SERVICE_CODE_12', 'UPS 3 Day Select');
	define('UPS_SERVICE_CODE_13', 'UPS Next Day Air Saver');
	if (defined('MODULE_SHIPPING_UPSXML_RATES_ORIGIN') && MODULE_SHIPPING_UPSXML_RATES_ORIGIN == 'Canada Origin') {
		define('UPS_SERVICE_CODE_14', 'UPS Express Early');
	} else {
		define('UPS_SERVICE_CODE_14', 'UPS Next Day Air Early');
	}
	if (defined('MODULE_SHIPPING_UPSXML_RATES_ORIGIN') && MODULE_SHIPPING_UPSXML_RATES_ORIGIN == 'Poland Origin') {
		define('UPS_SERVICE_CODE_54', 'UPS Express Plus');
	} else {
		define('UPS_SERVICE_CODE_54', 'UPS Worldwide Express Plus');
	}
	define('UPS_SERVICE_CODE_59', 'UPS 2nd Day Air A.M.');
	if (defined('MODULE_SHIPPING_UPSXML_RATES_ORIGIN') && ((MODULE_SHIPPING_UPSXML_RATES_ORIGIN == 'Canada Origin') || (MODULE_SHIPPING_UPSXML_RATES_ORIGIN == 'Poland Origin'))) {
		define('UPS_SERVICE_CODE_65', 'UPS Express Saver');
	} else {
		define('UPS_SERVICE_CODE_65', 'UPS Worldwide Saver');
	}
	define('UPS_SERVICE_CODE_70', 'UPS Access Point Exonomy');
	define('UPS_SERVICE_CODE_82', 'UPS Today Standard');
	define('UPS_SERVICE_CODE_83', 'UPS Today Dedicated Courier');
	define('UPS_SERVICE_CODE_85', 'UPS Today Express');
	define('UPS_SERVICE_CODE_86', 'UPS Today Express Saver');
	define('UPS_SERVICE_CODE_92', 'UPS SurePost less than 1 pound');
	define('UPS_SERVICE_CODE_93', 'UPS SurePost 1 pound or more');
	define('UPS_SERVICE_CODE_94', 'UPS SurePost BPM');
	define('UPS_SERVICE_CODE_95', 'UPS SurePost Media');
	define('UPS_SERVICE_CODE_96', 'UPS Worldwide Express Freight');
	define('MODULE_SHIPPING_UPSXML_TEXT_BILLED_WEIGHT', 'billed dimensional weight ');
	define('MODULE_SHIPPING_UPSXML_TEXT_EDD', 'Estimated Delivery: ');
	define('MODULE_SHIPPING_UPSXML_TEXT_INSURED', 'Fully Insured');
	define('MODULE_SHIPPING_UPSXML_TEXT_NOTINSURED', '<strong>NOT</strong> Insured');
	define('MODULE_SHIPPING_UPSXML_TEXT_TOTAL', ' total');
	define('MODULE_SHIPPING_UPSXML_TEXT_PKGS', 'packages');
	define('MODULE_SHIPPING_UPSXML_TEXT_PKG', 'package');
	define('MODULE_SHIPPING_UPSXML_TEXT_LBS', 'pounds');
	define('MODULE_SHIPPING_UPSXML_TEXT_OZ', 'ounces');
	define('MODULE_SHIPPING_UPSXML_TEXT_KGS', 'kilograms');
	define('MODULE_SHIPPING_UPSXML_TEXT_SUREPOST_DEL', 'at least one day after UPS Ground');
	define('MODULE_SHIPPING_UPSXML_TEXT_SIG', 'Signature Required');
	define('MODULE_SHIPPING_UPSXML_TEXT_ASIG', 'Adult Signature Required');
	define('MODULE_SHIPPING_UPSXML_ERROR_POBOX', 'ERROR: UPS SurePost&reg; is not available for this shipment and PO Box shipments are not valid for any other UPS service.');
?>